import { RFValue } from 'react-native-responsive-fontsize';
import styled from 'styled-components/native';
import { Pressable } from '../../../Pressable';
import { RSValue } from '../../../RFValue';
import { TextNative } from '../../../TextNative';
import {themeDefault} from "../../../AppProvider/ITheme";

export const BorderRoundedTop = styled.View`
   background: white;
   border-top-right-radius: 20px;
   border-top-left-radius: 20px;
   min-height: 20px;
   padding: 0px ${RSValue(8)}px;
   padding-left: ${RSValue(15)}px;
   height: ${RSValue(45)}px;
   flex-direction: row;
`;

export const FilterBtn = styled(Pressable)`
   background: ${(props) => props.theme.primary || themeDefault.primary};
   border-radius: 100px;
   padding: ${RSValue(6)}px ${RSValue(15)}px;
`;

export const TextFilter = styled(TextNative)`
   color: white;
   font-size: ${RFValue(13)}px;
`;

export const TagsFiltersContainer = styled.View<any>`
   height: ${(props) => (props.view ? RSValue(35) : RSValue(0))}px;
`;
